//Fluchtdiagramm für die Standardmap
//Es kommt wegen der multithreaded Graphic zu einigen wenigen Pixelfehlern
//////////////////////////////////////////////////////////////////////////////////
public class MyThread extends Thread {  
  double xmin,ymin;
  color farbe;
  PGraphics pg;
  int maxiterations;
  double massFuerUnendlich;
  double x0,y0,xAlt,yAlt,xNeu,yNeu;
  double wh;
  double K;
  protected boolean running = false;
  

  //-----------------------------------------
  // Thread anlegen und Parameter übergeben
  //-----------------------------------------
  
  public MyThread(double px0, double py0, int pmaxiterations, double pmUnendlich, double pwh, double KFaktor) {
    // benötigte Parameter
    K = KFaktor;
    wh = pwh;
    xmin=px0; ymin=py0; 
    maxiterations = pmaxiterations;
    massFuerUnendlich = pmUnendlich; 
    pg = createGraphics(width,height/anzahlThreads);
    //println(anzahlThreads);
  }

 //////////////////////////////////////////////////////////////  
  public void run() {
    
    this.running = true;
    pg.beginDraw();
      pg.loadPixels();
        // x wird von xmin nach ixmax iteriert
        double xmax = xmin + anzahlThreads*wh;
       // println("x: "+xmin,xmax);//Information
        double ymax = ymin + wh;
        //println("y: "+ymin,ymax);//Information
      
        // die inkrimentelle Erhoehung für x und y
        double dx = (xmax - xmin) / (pg.width);
        double dy = (ymax - ymin) / (pg.height);
      
        double y = ymin;
        for (int j = 0; j < pg.height; j++) {
          double x = xmin;
          for (int i = 0; i < pg.width; i++) {
            double n = standardMapIteration(x, y, maxiterations);
            pg.pixels[i+j*pg.width] = colorize(n); 
            x += dx;
          }   
          y += dy;
        }
       pg.updatePixels();     
    pg.endDraw();   
    this.running = false;
   
  }
  
/////////////////////////////////////////////////////////////////////
double standardMapIteration(double xH, double yH, int maxN) {

  //Standardmap Algorithmus
  int  maxit = maxN;
  double d = 0;
  x0 = xH; y0=yH;
  xAlt = xH; yAlt = yH;
 
  int i = 0;
  while (i < maxit) {
    yNeu = yAlt + K*Math.sin(xAlt); 
    xNeu = (xAlt + yNeu);// % (2*PI);  
  //  if(xNeu <0) xNeu = 2*PI+xNeu;//damit  xNeu > 0
   
     if (d > massFuerUnendlich) {
      break;  // Raus!
    }
     d = 100*Math.sqrt((x0-xNeu)*(x0-xNeu)+(y0-yNeu)*(y0-yNeu)); 
    xAlt = xNeu;yAlt = yNeu;
    i++;
  }

  return d;
 }
/////////////////////////////////////////////////////////////
color colorize(double n) {
  // jedes Pixel wird entsprechend der Anzahl Iterationen eingefärbt
  
  if (n >= maxiterations){  
    return color(0);
  }else{
   color col = color((int)n,255,255);//color((int)(n+128)%255,255,(int)(6*n)%255); 
    return col; 
  }
 }
//////////////////////////////////////////
}
